#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "io.h"

#define PIN_DATA 0
#define PIN_CLK  1
#define PIN_ACK  2
#define PIN_IN   3
#define PIN_LED  4

#include "bus.h"

void init_interrupt()
{
	MCUSR = 0;
	wdt_disable();
	DDRB &= ~(1<<PB3); /* Set PB0 as input */
	PORTB |= (1<<PB3); /* Activate PULL UP resistor */ 

	PCMSK |= (1 << PCINT3); /* Enable PCINT0 */
	GIMSK |= (1 << PCIE); /* Activate interrupt on enabled PCINT7-0 */
	sei ();
}
int main()
{
	int  wait=0, state=0;
	unsigned long last=0;
	bus_t bus;
	init();
	init_write_pin(PIN_DATA,PIN_CLK,PIN_ACK);
	//init_interrupt();
	pinMode(PIN_IN, INPUT);
	pinMode(PIN_LED, OUTPUT);
	bus_init_send(&bus, PIN_DATA, PIN_CLK, PIN_ACK);
	while(1)
	{
		if(!wait && read_pin(PIN_IN) )
		{
			unsigned long val;
			val=micros()-last;
			if(val<5000) continue;
			wait=1;
			last=micros();
			//bus_write_sync(&bus, &val, 4);
			state=(!state)?1:0;
			digitalWrite(PIN_LED, state);
		}
		
		if(!read_pin(PIN_IN)) wait=0;
	}
}






/*
 * #include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "io.h"

#define PIN_DATA 0
#define PIN_CLK  1
#define PIN_ACK  2
#define PIN_IN   3
#define PIN_LED  4

#include "bus.h"

void init_interrupt()
{
	MCUSR = 0;
	wdt_disable();
	DDRB &= ~(1<<PB3); 
	PORTB |= (1<<PB3); 

	PCMSK |= (1 << PCINT3); 
	GIMSK |= (1 << PCIE); 
	sei ();
}

bus_t bus;

int main()
{
	init();
	init_write_pin(PIN_DATA,PIN_CLK,PIN_ACK);
	init_interrupt();
	pinMode(PIN_IN, INPUT);
	pinMode(PIN_LED, OUTPUT);
	bus_init_send(&bus, PIN_DATA, PIN_CLK, PIN_ACK);
	while(1)
	{
		//bus_send_thread(&bus);
	}
}

unsigned long last=0;
uint8_t ledstate=0;

ISR (PCINT0_vect){
   uint8_t x = (PORTB&(1<<PB3))>>PB3;
   if(x)
   {
		 uint32_t val=micros()-last;
		 last=micros();
		 bus_write(&bus, &val, 4);
		 ledstate=(ledstate)?0:1;
		 digitalWrite(PIN_LED, ledstate);
	 }
}

*/


